#ifndef ERRDEFS_H
#define ERRDEFS_H

/* ERRDEFS -- Definition of all symbolic names for VICAR2 internal
 * errors.  This module is used by the VICAR2 routines themselves
 * as well as application programs.
 *
 *	NOTE :  This file is built by ERRORBLD.COM.  It should never
 *		be modified directly.  To make changes to the source,
 *		change ERRORBLD.COM.
 *
 */
#define UNDEFINED_OPTIONAL -2
#define NO_FREE_UNITS -3
#define INSUFFICIENT_MEMORY -4
#define UNABLE_TO_STORE_OPTIONAL -5
#define NO_SUCH_UNIT -6
#define CANNOT_MOD_OPEN_UNIT -7
#define STRING_HAS_NON_ASCII_CHARS -8
#define IMPROPER_IMAGE_SIZE_PARAM -9
#define IMPROPER_METHOD_STRING -10
#define IMPROPER_OP_STRING -11
#define IMPROPER_FORMAT_STRING -12
#define ODD_NUMBER_OF_OPTIONALS -13
#define FILE_IS_ALREADY_OPEN -14
#define BAD_FILE_PARAM_NAME -15
#define NO_IO_TO_TERMINAL -16
#define IMAGE_SIZE_REQUIRED -17
#define IMPROPER_DIMENSION -18
#define ARRAY_IO_NOT_ALLOWED -19
#define CANNOT_DELETE_SECTION -20
#define IO_WAIT_FAIL -21
#define INTERNAL_ERROR -22
#define UNABLE_TO_ACQUIRE_AN_EVENT_FLAG -23
#define IMPROPER_CONVERT_SETTING -24
#define FILE_NOT_OPEN -25
#define BAD_PARAM_INSTANCE -26
#define NOT_IMPLEMENTED -27
#define BAD_ORG -28
#define BAD_INPUT_LABEL -29
#define END_OF_FILE -30
#define UNABLE_TO_OPEN_PRIMARY_INPUT -31
#define IMPROPER_INTFMT -32
#define IMPROPER_OPERATION -33
#define HIST_NAME_HAS_NON_ASCII_CHAR -34
#define INVALID_HOST -35
#define IMPROPER_REALFMT -36
#define NO_TASKS_IN_LABEL -37
#define CANNOT_FIND_KEY -38
#define BAD_LABEL_TYPE -39
#define ORG_MISMATCH -40
#define ERR_MESS_TOO_LONG -41
#define NO_MEMORY_FOR_LABEL_PROCESS -42
#define START_REC_ERROR -43
#define NO_SUCH_TASK -44
#define NO_SUCH_KEY -45
#define NO_SYSTEM_LABEL -46
#define ILLEGAL_INSTANCE -47
#define ILLEGAL_FORMAT_REQUEST -48
#define CONVERSION_ERROR -49
#define HOST_TOO_LONG -50
#define IMPROPER_LABEL_INSTANCE -51
#define CAN_NOT_MODIFY_AN_INPUT_LABEL -52
#define IMPROPER_LENGTH -53
#define IMPROPER_SAMP_SIZE_PARAM -54
#define IMPROPER_LINE_SIZE_PARAM -55
#define NULL_REQUEST -56
#define END_OF_LABEL -57
#define ILLEGAL_TAPE_OPERATION -58
#define ILLEGAL_TAPE_METHOD -59
#define IMPROPER_BAND_SIZE_PARAM -60
#define TAPE_POSITIONING_ERROR -61
#define PARM_FILE_VERSION -62
#define TOO_LATE -63
#define FILE_HAS_NO_LABEL -64
#define DUPLICATE_KEY -65
#define IMPROPER_BINARY_SIZE_PARAM -66
#define COND_STRING_TOO_LONG -67
#define ACT_STRING_TOO_LONG -68
#define BAD_ERR_ACT_VALUE -69
#define IMPROPER_ELEMENT_NUMBER -70
#define FORMAT_OPTIONAL_REQUIRED -71
#define VARREC_ERROR -72
#define IMPROPER_FILE_NUMBER -73
#define BUF_NOT_MULT_OF_REC -74
#define END_OF_VOLUME -75
#define NO_TAPE_SUPPORT -76
#define NOT_PARAMETER_FILE -77
#define MULTIPLE_PARAMETER_FILES -78
#define BAD_FILE_TYPE -79
#define INVALID_FORMAT_TRANSLATION -80
#define NO_TAE_SUPPORT -81
#define NON_SEQUENTIAL_WRITE -82
#define DEVICE_NOT_MOUNTED -83
#define XVCOMMAND_ERROR -84
#define XVCOMMAND_FAIL -85
#define PARAM_NOT_FOUND -86
#define BLTYPE_TOO_LONG -87
#define PARBLK_ERROR -88
#define IMPROPER_MODE_STRING -89
#define NO_SUCH_PROPERTY -90
#define PROPERTY_OPTIONAL_REQUIRED -91
#define UNDEF_ENV_VAR -92
#define UNDEF_USER_NAME -93
#define UNCLOSED_BRACES -94
#define NAME_TRUNCATED -95
#define IMPROPER_UPD_HIST_SETTING -96
#define FILE_TOO_BIG -97
#define LAST_ERROR -97
#endif /* ERRDEFS_H */
