#include "xvmaininc.h"
#include "defines.h"

/* Convert the ascii item in 'text' to its real, double, integer, or	*/
/* string form.								*/
/* NOTE:  The converted value is kept in an internal static buffer	*/
/* (*converted_item is set to it), so it better be used or copied	*/
/* elsewhere before this routine is called again.			*/

int v2_convert_from_text(converted_item, text, length, format)
char **converted_item;		/* out: ptr to resultant value */
char *text;			/* in: text to convert */
int length;			/* in: max length of an element */
char *format;			/* in: format of item */
{
   /* Under some circumstances, Solaris would not align this buffer     */
   /* when declared as char.  So we declare it as double in order to    */
   /* force alignment.                                                  */
   static double temp[(MAX_LABEL_VALUE_SIZE+1+sizeof(double)-1)/sizeof(double)];
   int atoi();
   double atof();
   char *dequoted();

   *converted_item = (char *)temp;

   if(EQUAL(format, "STRING"))
      strcpy((char *)temp, dequoted(text, MIN(strlen(text),length)));

   else if (EQUAL(format, "INT"))
      *(int *)temp = atoi(dequoted(text, strlen(text)));

   else if (EQUAL(format, "REAL"))
      *(float *)temp = (float)atof(dequoted(text, strlen(text)));

   else if (EQUAL(format, "DOUB"))
      *(double *)temp = atof(dequoted(text, strlen(text)));

   else
      return ILLEGAL_FORMAT_REQUEST;

   return SUCCESS;
}
