#include "xvmaininc.h"
#include "defines.h"

/* This function acts upon a substring of a label string, deleting the	*/
/* substring between 'start' and 'stop' (not including *stop) and	*/
/* inserting in its place the string 'label_item'.			*/

int cut_label_string(start,stop,label_item)
char *start,*stop,*label_item;
{
   int len;

   len = strlen(label_item);

   /* If label_item is too big to fit between start and stop, return	*/
   /* failure, since this routine does no re-allocation.		*/

   if (stop - start < len)
      return FAILURE;

   strncpy(start, label_item, len);	/* insert 'label_item' */
   strcpy(start+len, stop);		/* delete the rest     */

   return SUCCESS;
}
