#include "xvmaininc.h"

#if RTL_USE_TAE

#include "taeconf.inp"
#include "symtab.inc"
#include "defines.h"
#include "declares.h"
#include "externs.h"

/* Packs up a group of strings from a parameter into the format that	*/
/* XVSPTR wants.  This format should NOT be used by any new code; it is	*/
/* intended only for compatibility with old stuff.  There is *no*	*/
/* bounds checking on the output string.				*/

void pack_xvsptr(out, v, count)
char *out;			/* out: ptr to output string */
struct VARIABLE *v;		/* in: var struct containing strings */
int count;			/* in: # of strings to copy */
{
   int i;

   for (i=0; i<count; i++) {
      strcpy(out, SVAL(*v,i));
      out += strlen(SVAL(*v,i)) + 1;	/* +1 for null terminator */
   }
   return;
}

#else

void pack_xvsptr()
{
   return;
}

#endif

