#include "xvmaininc.h"
#include "defines.h"
#include "declares.h"
#include "externs.h"

/* Read a number of blocks from the file */

v2_read_blocks(devstate, buf, block, nblocks, async_flag)
struct devstate *devstate;
char *buf;
V2_OFFSET block, nblocks;
int async_flag;
{
   int status;

   switch (devstate->device_type) {
      case DEV_DISK:
         status = v2_read_disk(&devstate->dev.disk, buf, block, nblocks,
		  async_flag, &devstate->transfer_count, devstate->file_offset);
         break;
#if RTL_USE_TAPE
      case DEV_TAPE:
         status = v2_read_tape(&devstate->dev.tape, buf, block, nblocks,
			    async_flag, &devstate->transfer_count);
         break;
#endif
      case DEV_ANSI:
         status = NOT_IMPLEMENTED;
         break;
      case DEV_ARRAY:
         status = read_nop();
         break;
      default:
         status = NOT_IMPLEMENTED;
   }

   return status;
}
