#include "xvmaininc.h"
#include "defines.h"
#include "declares.h"
#include "externs.h"

/* Byte-swapping host format conversion routines.  They are currently	*/
/* used for all integer format conversions, and for real and doub	*/
/* between ieee and rieee only.						*/
/* It is a good idea to re-write at least some of these in assembler	*/
/* code, in a host-dependent file (like "int_convert_vms.mar"), then	*/
/* use #if's to remove the functions here that are not needed.		*/

int trans_swap2(from, to, len, trans)
short int *from;
short int *to;
int len;
struct trans *trans;
{
   register int i;
   register unsigned char temp;
   union short_u {
      short int i;
      unsigned char b[2];
   } u;

   for (i=0; i<len; i++) {
      memcpy(&u.i, from++, sizeof(short int));	/* in case an odd address */
      temp = u.b[0];
      u.b[0] = u.b[1];
      u.b[1] = temp;
      memcpy(to++, &u.i, sizeof(short int));
   }
   return SUCCESS;
}

int trans_swap4(from, to, len, trans)
int *from;
int *to;
int len;
struct trans *trans;
{
   register int i;
   register unsigned char temp;
   union long_u {
      int i;
      unsigned char b[4];
   } u;

   for (i=0; i<len; i++) {
      memcpy(&u.i, from++, sizeof(int));	/* in case an odd address */
      temp = u.b[0];
      u.b[0] = u.b[3];
      u.b[3] = temp;
      temp = u.b[1];
      u.b[1] = u.b[2];
      u.b[2] = temp;
      memcpy(to++, &u.i, sizeof(int));
   }
   return SUCCESS;
}

int trans_swap8(from, to, len, trans)
double *from;
double *to;
int len;
struct trans *trans;
{
   register int i;
   register unsigned char temp;
   union long_u {
      double i;
      unsigned char b[8];
   } u;

   for (i=0; i<len; i++) {
      memcpy(&u.i, from++, sizeof(double));	/* in case an odd address */
      temp = u.b[0];
      u.b[0] = u.b[7];
      u.b[7] = temp;
      temp = u.b[1];
      u.b[1] = u.b[6];
      u.b[6] = temp;
      temp = u.b[2];
      u.b[2] = u.b[5];
      u.b[5] = temp;
      temp = u.b[3];
      u.b[3] = u.b[4];
      u.b[4] = temp;
      memcpy(to++, &u.i, sizeof(double));
   }
   return SUCCESS;
}

