#include "xvmaininc.h"
#include "defines.h"
#include "declares.h"
#include "externs.h"
#include "errdefs.h"
#include "ftnbridge.h"

/* Set up the default error action and user message */

/************************************************************************/
/* Fortran-Callable Version						*/
/************************************************************************/

int FTN_NAME(xveaction)(char *action, char *message, ZFORSTR_PARAM)
{
   ZFORSTR_BLOCK
   char c_action[MAX_SHORT_STRING_SIZE+1];
   char c_message[MAX_STRING_SIZE+1];
   int status;

   zsfor2c(c_action, MAX_SHORT_STRING_SIZE, action, &action, 2, 1, 1, message);
   zsfor2c(c_message, MAX_STRING_SIZE, message, &action, 2, 2, 2, message);

   return zveaction(c_action, c_message);

}

/************************************************************************/
/* C-Callable Version							*/
/************************************************************************/

int zveaction(action, message)
char *action;
char *message;
{
   int status;
   char temp[MAX_SHORT_STRING_SIZE+1];

   if (strlen(action) > MAX_SHORT_STRING_SIZE)
      return BAD_ERR_ACT_VALUE;

   make_upper_case(temp, action);

   status = v2_error_action(temp);
   if (status != SUCCESS)
      return status;

   status = v2_error_mess(message);
   if (status != SUCCESS)
      return status;

   strcpy(def_err_act, temp);
   strcpy(def_err_mess, message);

   return SUCCESS;

}
